package kz.arta.synergy.workflow.mobile.android.common.offline.add;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;
import java.util.List;

import kz.arta.synergy.workflow.mobile.android.common.models.offline.OfflineRemoveAttachment;

/**
 * Created by neox on 11.08.14.
 */
public class AddRemoveAttachment extends SQLiteOpenHelper {

    private SQLiteDatabase db = getWritableDatabase();
    private static final String TABLE_NAME = "RemoveAttachment";
    private static final String TABLE = "create table " + TABLE_NAME + " ("
            + "actionID text,"
            + "nodeUUID text,"
            + "name text,"
            + "file_name text"
            + ");";

    public AddRemoveAttachment(Context context) {
        super(context, TABLE_NAME, null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {
        sqLiteDatabase.execSQL(TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i2) {

    }

    public boolean remove() {
        try {
            db.delete(TABLE_NAME, null, null);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public boolean add(String actionID, String nodeUUID, String name, String fileName) {
        try {
            db.delete(TABLE_NAME, "nodeUUID = ?", new String[]{nodeUUID});
            ContentValues cv = new ContentValues();
            cv.put("actionID", actionID);
            cv.put("nodeUUID", nodeUUID);
            cv.put("name", name);
            cv.put("file_name", fileName);
            db.insert(TABLE_NAME, null, cv);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public List<OfflineRemoveAttachment> get() {
        List<OfflineRemoveAttachment> result = new ArrayList<>();
        Cursor c = null;
        try {
            c = db.query(TABLE_NAME, null, null, null, null, null, null);
            if (c.moveToFirst()) {
                do {
                    OfflineRemoveAttachment item = new OfflineRemoveAttachment();
                    item.setActionID(c.getString(c.getColumnIndex("actionID")));
                    item.setNodeUUID(c.getString(c.getColumnIndex("nodeUUID")));
                    item.setName(c.getString(c.getColumnIndex("name")));
                    item.setFileName(c.getString(c.getColumnIndex("file_name")));
                    result.add(item);
                } while (c.moveToNext());
            }
            return result;
        } catch (Exception exc) {
            return result;
        } finally {
            if (c != null) {
                c.close();
            }
        }
    }
}
